/******************************************************************************/
/*  (C) COPYRIGHT International Business Machines Corp. 1993                  */
/*                            All Rights Reserved                             */
/*                                                                            */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THIS MATERIAL        */
/*  "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,        */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND FITNESS FOR A PARTICULAR PURPOSE.                                     */
/*                                                                            */
/******************************************************************************/
#include <X11/PEX5/PEXlib.h>
#include <misc.h>
#include <X11/PEX5/PEXExtlib.h>

#define SET_COLOR( r, g, b, c ) { \
	(c).rgb.red = (r); \
	(c).rgb.green = (g); \
	(c).rgb.blue = (b);}

/****************************************************************************
 *  Sample actual test. Draws a polyine.                                    *
 ***************************************************************************/
void draw_model(Display          *dpy,
               XID              resourceID,
               PEXOCRequestType req_type)

  {
    PEXCoord2D  dot1[] = {{.1,.85},{.2,.85},{.3,.85},{.4,.85}};
    PEXCoord2D  ast1[] = {{.1,.75},{.2,.75},{.3,.75},{.4,.75}};
    PEXCoord    dot2[] = {{.1,.65,.0},{.2,.65,.0},{.3,.65,.0},{.4,.65,.0}};
    PEXCoord    ast2[] = {{.1,.55,.0},{.2,.55,.0},{.3,.55,.0},{.4,.55,.0}};
    PEXCoord2D  dot3[] = {{.1,.35},{.2,.35},{.3,.35},{.4,.35}};
    PEXCoord2D  ast3[] = {{.1,.25},{.2,.25},{.3,.25},{.4,.25}};
    PEXCoord    dot4[] = {{.1,.15,.0},{.2,.15,.0},{.3,.15,.0},{.4,.15,.0}};
    PEXCoord    ast4[] = {{.1,.05,.0},{.2,.05,.0},{.3,.05,.0},{.4,.05,.0}};

    PEXCoord2D  dot5[] = {{.6,.85},{.7,.85},{.8,.85},{.9,.85}};
    PEXCoord2D  ast5[] = {{.6,.75},{.7,.75},{.8,.75},{.9,.75}};
    PEXCoord    dot6[] = {{.6,.65,.0},{.7,.65,.0},{.8,.65,.0},{.9,.65,.0}};
    PEXCoord    ast6[] = {{.6,.55,.0},{.7,.55,.0},{.8,.55,.0},{.9,.55,.0}};
    PEXCoord2D  dot7[] = {{.6,.35},{.7,.35},{.8,.35},{.9,.35}};
    PEXCoord2D  ast7[] = {{.6,.25},{.7,.25},{.8,.25},{.9,.25}};
    PEXCoord    dot8[] = {{.6,.15,.0},{.7,.15,.0},{.8,.15,.0},{.9,.15,.0}};
    PEXCoord    ast8[] = {{.6,.05,.0},{.7,.05,.0},{.8,.05,.0},{.9,.05,.0}};

    PEXColor	yellow, green;
    char        text[80];
    double      size;
    int         i;

    /* Define the colors */
    SET_COLOR( 1.0, 1.0, 0.0, yellow )
    SET_COLOR( 0.0, 1.0, 0.0, green )
    
    PEXExtSetPrimitiveAA(dpy, resourceID, req_type, PEXExtPrimAANone,
                         PEXExtPrimAABlendOpImpDep);

    size = 0.0;
    for(i=0; i<4; i++) {
       PEXSetMarkerScale(dpy, resourceID, req_type, size);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerDot);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &yellow);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &dot1[i]);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerAsterisk);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &green);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &ast1[i]);
       size += 2.0;
    }

    size = 0.0;
    for(i=0; i<4; i++) {
       PEXSetMarkerScale(dpy, resourceID, req_type, size);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerDot);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &yellow);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &dot2[i]);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerAsterisk);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &green);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &ast2[i]);
       size += 2.0;
    }

    PEXExtSetPrimitiveAA(dpy, resourceID, req_type, PEXExtPrimAANone,
                         PEXExtPrimAABlendOpSimpleAlpha);

    size = 0.0;
    for(i=0; i<4; i++) {
       PEXSetMarkerScale(dpy, resourceID, req_type, size);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerDot);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &yellow);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &dot3[i]);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerAsterisk);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &green);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &ast3[i]);
       size += 2.0;
    }

    size = 0.0;
    for(i=0; i<4; i++) {
       PEXSetMarkerScale(dpy, resourceID, req_type, size);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerDot);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &yellow);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &dot4[i]);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerAsterisk);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &green);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &ast4[i]);
       size += 2.0;
    }

    PEXExtSetPrimitiveAA(dpy, resourceID, req_type, PEXExtPrimAAPoint,
                         PEXExtPrimAABlendOpImpDep);

    size = 0.0;
    for(i=0; i<4; i++) {
       PEXSetMarkerScale(dpy, resourceID, req_type, size);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerDot);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &yellow);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &dot5[i]);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerAsterisk);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &green);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &ast5[i]);
       size += 2.0;
    }

    size = 0.0;
    for(i=0; i<4; i++) {
       PEXSetMarkerScale(dpy, resourceID, req_type, size);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerDot);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &yellow);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &dot6[i]);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerAsterisk);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &green);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &ast6[i]);
       size += 2.0;
    }

    PEXExtSetPrimitiveAA(dpy, resourceID, req_type, PEXExtPrimAAPoint,
                         PEXExtPrimAABlendOpSimpleAlpha);

    size = 0.0;
    for(i=0; i<4; i++) {
       PEXSetMarkerScale(dpy, resourceID, req_type, size);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerDot);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &yellow);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &dot7[i]);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerAsterisk);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &green);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &ast7[i]);
       size += 2.0;
    }

    size = 0.0;
    for(i=0; i<4; i++) {
       PEXSetMarkerScale(dpy, resourceID, req_type, size);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerDot);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &yellow);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &dot8[i]);
       PEXSetMarkerType(dpy, resourceID, req_type, PEXMarkerAsterisk);
       PEXSetMarkerColor(dpy, resourceID, req_type, PEXColorTypeRGB, &green);
       PEXMarkers2D(dpy, resourceID, req_type, 1, &ast8[i]);
       size += 2.0;
    }
}

/****************************************************************************
 *  Sets the test parameters                                                *
 ***************************************************************************/
void inquire_test_params(char *test_name,
                         int  *num_images,
                         int  *supported_modes,
                         char *win_title)


  {
    strcpy(test_name, "aa_point");
    *num_images = 1;
    *supported_modes = IMM_MODE | STR_MODE;

    strcpy(win_title, "IBM Anti-Aliasing Test - Point");
  }


/****************************************************************************
 *  This routine is used to do miscellaneous things like setting some       *
 *  renderer attributess, Viewing etc if needed.                            *
 ***************************************************************************/
void misc_setup(Display *dpy, Window window, PEXRenderer renderer,
                int cur_image)
  {
  }

/****************************************************************************
 *  This routine calls the function which does the actual test              *
 ***************************************************************************/
void execute_test(Display *dpy, XID resourceID,
               PEXOCRequestType req_type, int cur_image)
  {

    describe_test( "\n" );
    describe_test( " IBM Anti-Aliasing Test: Point\n");
    describe_test( "\n" );
    describe_test( " There will be two sections to the test image.  The top two rows will\n");
    describe_test( " have the blending mode set to PEXExtPrimAABlendOpImpDep and the\n");
    describe_test( " bottom two rows will be set to PEXExtPrimAABlendOpSimpleAlpha.\n");
    describe_test( "\n"); 
    describe_test( " This test will display markers (2D & 3D) of the types MarkerDot & Asterisk\n"); 
    describe_test( " at various sizes.  The AA mode will be set to PEXExtPrimAANone on the  \n"); 
    describe_test( " left and to PEXExtPrimAAPoint on the right.\n"); 
    describe_test( "\n"); 

    draw_model(dpy, resourceID, req_type);

  }

void testproc(Display *dpy, Window window, int cur_image)
  {
    image_testproc("aa_point", "IBM Anti-aliasing Point test", img_desc,
                    dpy,window, 0, 0,
                    glob_window_width, glob_window_height);
  }

